<?php
/* Autor...:  */
/* Esquema.: MST_TipoAfectacionIGV.xml */
/* Generado: 2022-01-20 22:55:24 */

/* Metodos de acceso a los campos de la tabla MST_TipoAfectacionIGV */
abstract class BaseMST_TipoAfectacionIGVBN
{
    /* Campos de la tabla */
    private $i_TipoIgvId;    // TipoIgvId: ( no definido )
    private $s_Descripcion;    // Descripcion: ( no definido )
    private $s_CodigoSunat;    // CodigoSunat: ( no definido )
    private $s_CodigoProv;    // CodigoProv: ( no definido )
    private $s_CodigoTributo;    // CodigoTributo: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $d_FechaRegistro;    // FechaRegistro: ( no definido )

    /* Establece el valor del campo TipoIgvId */
    public function setTipoIgvId( $i_TipoIgvId )
    {
        $this->i_TipoIgvId = $i_TipoIgvId;
    }

    /* Obtiene el valor del campo TipoIgvId */
    public function getTipoIgvId()
    {
        return $this->i_TipoIgvId;
    }

    /* Establece el valor del campo Descripcion */
    public function setDescripcion( $s_Descripcion )
    {
        $this->s_Descripcion = $s_Descripcion;
    }

    /* Obtiene el valor del campo Descripcion */
    public function getDescripcion()
    {
        return $this->s_Descripcion;
    }

    /* Establece el valor del campo CodigoSunat */
    public function setCodigoSunat( $s_CodigoSunat )
    {
        $this->s_CodigoSunat = $s_CodigoSunat;
    }

    /* Obtiene el valor del campo CodigoSunat */
    public function getCodigoSunat()
    {
        return $this->s_CodigoSunat;
    }

    /* Establece el valor del campo CodigoProv */
    public function setCodigoProv( $s_CodigoProv )
    {
        $this->s_CodigoProv = $s_CodigoProv;
    }

    /* Obtiene el valor del campo CodigoProv */
    public function getCodigoProv()
    {
        return $this->s_CodigoProv;
    }

    /* Establece el valor del campo CodigoTributo */
    public function setCodigoTributo( $s_CodigoTributo )
    {
        $this->s_CodigoTributo = $s_CodigoTributo;
    }

    /* Obtiene el valor del campo CodigoTributo */
    public function getCodigoTributo()
    {
        return $this->s_CodigoTributo;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo FechaRegistro */
    public function setFechaRegistro( $d_FechaRegistro )
    {
        $this->d_FechaRegistro = $d_FechaRegistro;
    }

    /* Obtiene el valor del campo FechaRegistro */
    public function getFechaRegistro()
    {
        return $this->d_FechaRegistro;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'TipoIgvId' => $this->getTipoIgvId(),
            'Descripcion' => $this->getDescripcion(),
            'CodigoSunat' => $this->getCodigoSunat(),
            'CodigoProv' => $this->getCodigoProv(),
            'CodigoTributo' => $this->getCodigoTributo(),
            'Estado' => $this->getEstado(),
            'FechaRegistro' => $this->getFechaRegistro(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto MST_TipoAfectacionIGVBN desde un RecordSet */
    public static function retrieveByRs( $o_MST_TipoAfectacionIGVRs )
    {
        $o_MST_TipoAfectacionIGVBN = new MST_TipoAfectacionIGVBN();
        $o_MST_TipoAfectacionIGVBN->setTipoIgvId( ( integer ) $o_MST_TipoAfectacionIGVRs[ "TipoIgvId" ] );
        $o_MST_TipoAfectacionIGVBN->setDescripcion( $o_MST_TipoAfectacionIGVRs[ "Descripcion" ] );
        $o_MST_TipoAfectacionIGVBN->setCodigoSunat( $o_MST_TipoAfectacionIGVRs[ "CodigoSunat" ] );
        $o_MST_TipoAfectacionIGVBN->setCodigoProv( $o_MST_TipoAfectacionIGVRs[ "CodigoProv" ] );
        $o_MST_TipoAfectacionIGVBN->setCodigoTributo( $o_MST_TipoAfectacionIGVRs[ "CodigoTributo" ] );
        $o_MST_TipoAfectacionIGVBN->setEstado( $o_MST_TipoAfectacionIGVRs[ "Estado" ] );
        $o_MST_TipoAfectacionIGVBN->setFechaRegistro( utilTimestamp::getTimestamp( $o_MST_TipoAfectacionIGVRs[ "FechaRegistro" ], "Y-m-d H:i:s" ) );
        return $o_MST_TipoAfectacionIGVBN;
    }
}
?>